#include<string>
#include<fstream>
#include"pssm.h"
using namespace std;

pssm::pssm()
{
}

int pssm::elongation(coin *p,int i,int j,double *x)
{
	double score,scoj;
	int k;
	int e;
	coin *r;
	score=-1000000;                
	if(this->transition[i]!=-300){
		r=p->next;
		for(k=1;k<=len;k++){
		if(r->previous->nucleotide!=5)r=r->previous;
		else break;
		}
		scoj=-1100;
		if(k==len+1){
			scoj=r->s[j].score+this->transition[i];
			while(r!=p->next){
				scoj+=this->emi[len-k+1][r->nucleotide];
				k--;
				r=r->next;
			}
	  }
	  if(scoj>score)score=scoj;
	}
	*x=score;
	return len;
}


void pssm::read_para(string statename,int num)
{
  string s;
  int i,j;
  ifstream infile("para.txt",ios::in);
  while(infile>>s){
    if(s==statename)break;
  }
  while(infile>>s){
    if(s=="[Length]")break;
  }
  infile>>len;
  while(infile>>s){
    if(s=="[PSSM]")break;
  }
  for(i=0;i<len;i++){
    for(j=0;j<4;j++){
      infile>>emi[i][j];
    }
    emi[i][j]=-300;
  }
  while(infile>>s){
    if(s=="[Transition]")break;
  }
  for(i=0;i<=num;i++){
    infile>>transition[i];
  }
}
