#include<stdlib.h>
#include<fstream>
#include<string>
using namespace std;

void printhead()
{
  ofstream outfile("train/m.cpp",ios::out);
  outfile<<"#include<fstream>\n";
  outfile<<"#include<cstring>\n";
  outfile<<"#include\"geotrain.h\"\n";
  outfile<<"#include\"exptrain.h\"\n";
  outfile<<"#include\"pssmtrain.h\"\n";
  outfile<<"using namespace std;\n\n";
  outfile<<"void transfer();\n\n";
  outfile<<"int main()\n{\n";
  outfile<<"\ttransfer();\n";
}

int main()
{
  printhead();
  string s,sn;
  int states;
  ifstream in("prepara.txt",ios::in);
  while(in>>s){
    if(s=="[STATES]")break;
  }
  in>>states;
  string sname[states];
  while(in>>s){
    if(s=="[NAME]")break;
  }
  for(int i=0;i<states;i++){
    in>>sname[i];
  }
  short type[states];
  while(in>>s){
    if(s=="[TYPE]")break;
  }
  for(int i=0;i<states;i++){
    in>>type[i];
  }
  while(in>>s){
    if(s=="[NULL]")break;
  }
  in>>sn;
  in.close();
  ofstream outfile("train/m.cpp",ios::app);
  in.open("prepara.txt",ios::in);
  short t=0;
  for(int i=0;i<states;i++){
    if(type[i]==t){
      outfile<<","<<sname[i];
    }else{
      if(t!=0)outfile<<";\n";
      if(type[i]==1)outfile<<"\tgeo ";
      else if(type[i]==2)outfile<<"\texp ";
      else outfile<<"\tpssmt ";
      outfile<<sname[i];
    }
    t=type[i];
  }
  outfile<<";\n";
  if(sn!="-"){
    outfile<<'\t'<<sn<<".setname(\""<<sn<<"\");\n";
    outfile<<'\t'<<sn<<".geotrain();\n";
  }
  for(int i=0;i<states;i++){
    if((type[i]==1)&&(sname[i]!=sn)){
      outfile<<'\t'<<sname[i]<<".setname(\""<<sname[i]<<"\");\n";
      outfile<<'\t'<<sname[i]<<".geotrain();\n";
    }else if(type[i]==2){
      while(in>>s){
	if(s=="[Max_Length]")break;
      }
      int max;
      in>>max;
      outfile<<'\t'<<sname[i]<<".setname(\""<<sname[i]<<"\""<<","<<max<<");\n";
      outfile<<'\t'<<sname[i]<<".exptrain();\n";
    }else if(type[i]==3){
      while(in>>s){
	if(s=="[Length]")break;
      }
      int leng;
      in>>leng;
      outfile<<'\t'<<sname[i]<<".setname(\""<<sname[i]<<"\""<<","<<leng<<");\n";
      outfile<<'\t'<<sname[i]<<".pssmtrain();\n";
    }
  }
  outfile<<"}\n";
  outfile.close();
  system("g++ train/m.cpp train/geotrain.cpp train/exptrain.cpp train/pssmtrain.cpp train/transfer.cpp -o ta.exe");
  system("./ta.exe");
  system("./train/temp2p.exe");
  system("rm para.tmp.txt");
  system("rm ta.exe");
  system("rm train/m.cpp");
}
